#!/usr/bin/perl

# display.pl
#
# Display an image to stdout, with http headers.
#


#use Image::Magick;

$Id = $q->param('id');
$Type = $q->param('type');
# Size is: 0 = full, 1 = 640x480, 2 = full
$Size = $q->param('size');

$Conn = db_connect();

if ($Conn == -1) {
	print "Error connecting to database!\n";
	exit(0);
}

$Date = db_get_insdate($Id);

if (!db_image_exists($Id)) {
	print "Image $Id does not exist!\n";
	exit(0);
}

$Length = db_get_image_size($Id,$Type);

print "Content-type: image/jpeg\n";
print "Last-Modified: $Date\n";
print "Expires: ",$q->date_rfc1123(time + 86400),"\n\n";

$fh = db_get_image_fh($Id,$Type);

if (!$fh) {
	print "Error getting filehandle\n";
	exit(0);
}

while (<$fh>) {
	print $_;
}

close $fh;

