#!/usr/bin/perl

#
# InfoTable: Generate HTML table of image info
# GetPrev: Get and display thumb for previous image
# GetNext:  Get and display thumb for next image
# Main: main function


# main
# ./image.cgi", $file, $viewone, "$term";

$q = new CGI, unless $q;
chdir "$RealDir";

$Imageid = $q->param('id');
$Size = $q->param('size');
$Info = $q->param('info');
$Album = $q->param('alb');

if ($ARGV[0] =~ /^[0-9]+$/) {
	$Imageid = $ARGV[0];
}
if ($ARGV[1] =~ /^[0-9]+$/) {
	$Next = $ARGV[1];
}
if ($ARGV[2] !~ /^$/) {
	$Terms = $ARGV[2];
	$NextView = "|<a href=search?terms=$Terms&vdone=$Next>Next File</a>\n";
}

db_connect();

$User = Userverify($q,1);
$Referer = $ENV{'HTTP_REFERER'};
my($URI) = $ENV{'REQUEST_URI'};


if (db_connect() == -1) {
	print "Error connecting to database";
	exit(0);
}


if (!db_img_viewable($Imageid, $User)) {
	print "Location: login\n\n";
	exit(0);
}

PrintHeader($User, "Viewing image", "", "Viewing photo"), unless ($Info);

$qry = "SELECT * FROM photos WHERE imageid = $Imageid";
($id,$filename,$filesize,$width,$height,$directory,$format,$origin,$cameramake,
$cameramodel,$createdate,$insertdate,$subtype,$status,$copyright,
$lighting,$filmiso,$filmexposure,$filmaperture,$filmmetering,$filmfoclen,
$flash,$quality,$whitebal,$expmode,$country,$city,$keywords,
$comment,$caption,$owner,$thumbsize,$smallwidth,$smallheight,$thumbwidth,
$thumbheight, $pub, $createtm,$inserttm) = $Db_Conn->selectrow_array($qry);

$caption =~ s/__APOSTROPHE__/\'/g;

if ($Info) {
	InfoTable($Imageid);
	exit(0);
}

$RowCount = 1;

print <<EOF;

<title>PhotoShelf: Viewing $filename</title>
<script language=javascript src=$Repos_Url/functions.js>

</script>

EOF


print "<center>";

if ($User eq $owner) {
print <<EOF;
<form method=post action=albumedit>
<input type=hidden name=album value=$Album>
<input type=hidden name=titlepic value=$Imageid>
<input type=hidden name=id value=$Imageid>
EOF
}
if ($Size == 1 || $Size == 0 && $smallwidth < 640) {
	$tabsize = "width=640";
} else {
	$tabsize = "";
}

print <<EOF;
<table border=0 cellspacing=0 cellpadding=0 $tabsize>
<tr bgcolor=$TableHighBG><td align=left>
EOF

if ($Album > 0) {
	print AlbumShowAncestor($Album, "", 1);
	$RowCount++;
	print "</td><td align=right>";
}
my $dt = ($createtm ? localtime($createtm) : "Unknown");
print <<EOF;
<b>Full Resolution:</b><br>
<b>Capture date:</b>
</td><td>
$width x $height<br>$dt</td><td>
<b><a href=\"javascript:popUp('image.cgi?id=$Imageid&info=1')\">Detailed info</a>
</b>
EOF
$RowCount+=2;

$caption = $filename, if ($caption =~ /^$/);

if (!db_img_viewable($Imageid, "nobody")) {
	print "<a href=edit?id=$Imageid&unlock=1><img src=$IcoUrl/mini-lock.gif width=16 height=14 border=0 alt=\"locked\"></a>";
}


print "</td></tr><tr><td valign=top align=right colspan=$RowCount><center><hr><font size=+1>$caption</font></center>";

$AltSize = "";

if ($Size == 1 || $Size == 0) {
	$type=1;
	$thew = $smallwidth;
	$theh = $smallheight;
	if ($User eq $owner && ($theh != $height || $thew != $width)) {
		if ($URI =~ /(.*)(&size=[0-9])+/) {
			$URI =~ s/&size=[0-9]/&size=2/g;
		} else {
			$URI .= "&size=2";
		}
		$AltSize = "<a href=\"$URI\"><img src=$IcoUrl/zoom.gif width=16 height=14 alt=\"Full Size\" border=0></a> |";
	}
} elsif ($User eq $owner && ($smallheight != $height || $smallwidth != $width)) {
	$type = 2;
	$thew = $width;
	$theh = $height;
	if ($URI =~ /(.*)(&size=[0-9])+/) {
			$URI =~ s/&size=[0-9]/&size=1/g;
	} else {
		$URI .= "&size=1";
	}
	$AltSize = "<a href=\"$URI\"><img src=$IcoUrl/zoom.gif width=16 height=14 alt=\"Small Size\" border=0></a> |";
} else {
	$AltSize = "";
}
#$imgfil = $URI . db_get_image_file($Imageid,$type);
$imgfil = $Repos_Url . db_get_image_file($Imageid,$type);

if ($User eq $owner) {
	if ($Album > 0) {
		$Alb = "&refalbum=$Album";
	} else {
		$Alb = "";
	}
	$edit="&nbsp;<a href=\"edit.cgi?id=$Imageid$Alb\"><img src=$IcoUrl/mini-hammer.gif width=16 height=14 alt=Edit border=0></a>&nbsp;|&nbsp;"
} else {
	$edit = "";
}
print "<center>\n";

ImgBorder($imgfil, $thew, $theh);

print "</center>\n";

if ($comment ne "") {
	print <<EOF;
<center><i>$comment</i></center><br>
EOF
}
if ($Album > 0) {
	$ImgNav = "";
	my($prev, $next) = AlbumNext($Album, $Imageid);
	print "<center>";
	if ($prev > 0) {
		print "<a href=image.cgi?id=$prev&alb=$Album><img src=$IcoUrl/left.gif width=22 height=22 border=0 alt=Prev></a>&nbsp;";
	} else {
		print "<img src=$IcoUrl/mini-trans.gif width=22 height=22>";
	}
	print "<a href=albumshow?album=$Album&page=1><img src=$IcoUrl/up.gif width=22 height=22 alt=\"Album\" border=0></a>";
	if ($next > 0) {
		print "<a href=image.cgi?id=$next&alb=$Album><img src=$IcoUrl/right.gif width=22 height=22 border=0 alt=Next></a>";
	} else {
		print "<img src=$IcoUrl/mini-trans.gif width=22 height=22>";
	}
	print "</center>";
}

print <<EOF;

</td></tr><tr><td align=left>
EOF
	if ($User eq $owner) {
		print <<EOF;
<input type=submit value="Set as Album title"></form>
EOF
	} else {
	print "<small><i>&copy; $copyright</i></small>";
	}
$RowC = $RowCount -1;
print <<EOF;
</td><td align=right valign=top colspan=$RowC>
$AltSize$edit
<a href=><img src=$IcoUrl/home.gif width=16 height=14 alt="Top" border=0></a>&nbsp;|&nbsp;<a href="javascript:popUp('help.cgi?topic=image')"><img src=$IcoUrl/help.gif width=16 height=14 alt=Help border=0></a>
&nbsp;$NextView
<p>
EOF

AddAlbumBox(), unless ($Album > 0 || $User eq "nobody");
print <<EOF;
</td></tr>
</table>
EOF
PrintFooter();

sub InfoTable {
my($id) = @_;

	print <<EOF;
Content-type: text/html

<title>PhotoShelf: Image info for $filename</title>
<body bgcolor=$BGNorm text=$TextNorm>
<table border=1 bgcolor=$TableHighBG align=center>

EOF

	foreach $field (0..$#DisplayedInfo) {
		$dbvar = $DisplayedInfo[$field][0];
		$descr = $DisplayedInfo[$field][1];
		$convert = $DisplayedInfo[$field][2];
		$vartype = $DisplayedInfo[$field][6];
		if ($convert) {
			($undef, ${$dbvar}) = db_id_to_nd($dbvar, ${$dbvar});
		}
		$desc = ${$dbvar};
		$desc =~ s/__APOSTROPHE__/\'/g, if ($vartype == 0);
		if ($vartype == 2) {
			$desc = ($desc ? localtime($desc) : "Unknown");
		}
	print <<EOF
<tr><td bgcolor=$TableLowBG><font size=-1 color=$TextLoTable>$descr</td><td><font size=-1>&nbsp;$desc</td></tr>
EOF
;
	}
	print "</table>";
	print "<a href=javascript:window.close()>Close window</a><br>";
}

sub AddAlbumBox {
print <<EOF;
<table valign=bottom border=0 cellspacing=0 bgcolor=$TableHighBG>
<tr bgcolor=$TableLowBG><th colspan=2><font color=$TextLoTable>Add To Album</th
></tr>
<tr><td><font color=$TextTable>
&nbsp;
<form method=post action=$URI/index.cgi/albumaddpic>
Add to album:
<input type=hidden name=image value=$Imageid>
<select name=albuminsert>
<option selected>
EOF

        @Albums = AlbumList("", -1);
        foreach $alb (@Albums) {
                ($owner, $album,$id) =split(/:/, $alb);
                print  "<option value=$id>$album\n", if ($owner eq $User);
        }

print <<EOF;
</select>
<td align=right><input type=submit value="Add">
</td>
</tr></table></form>
EOF
}
