#!/usr/bin/perl


db_connect();

$q = new CGI, unless $q;
$User = Userverify($q), unless defined $Album;


$Album = $q->param('album');
$Image = $q->param('id');
$Action = $q->param('action');
$Delete = $q->param('delete');
$TitlePic = $q->param('titlepic');
$Move = $q->param('move');
$Edit = $q->param('edit');
$AName = $q->param('albumname');
$ADescr = $q->param('albumdescr');
$AKeyw = $q->param('albumkeywords');
$APublic = $q->param('public');
$ACancel = $q->param('cancel');
$Ref = $q->param('where');
$AParent = $q->param('newparent');

$Referer = $ENV{'HTTP_REFERER'};

if ($Action eq "edit") {
	if (!AlbumExists($Album) || $ACancel eq "Cancel") {
		print "Location: " . ForceUrl("albumlist?level=$AParent") . "\n\n";
		exit(0);
	}
	if ($Delete eq "Delete") {
		($name) = AlbumIdName($Album);
		if ($name eq "Default") {
			exit(0);
		}
		@pics = AlbumListPix($Album, 1);
		if (@pics > 0) {
			print "\n\nError: Album not empty - delete images first!";
			exit(0);
		}
		DeleteAlbum($User, $Album);
		print "Location: " . ForceUrl("albumlist?level=$AParent") . "\n\n";
		exit(0);
	}
	AlbumTitle($Album, 0, $AName);
	AlbumKeywords($Album, 0, $AKeyw);
	AlbumPublic($User, $AName, $APublic);
	AlbumDescr($Album, 0, $ADescr);
	AlbumParent($Album, $AParent), unless (AlbumParent($Album, -1) == $AParent);
	UpdateAccess($Album, 0, 1);
	$tm = time();
	if ($Ref eq "albumlist") {
		$url = "albumlist?level=$AParent";
	} elsif ($Ref eq "albumshow") {
		$url = "albumshow?album=$Album";
	} else {
		$url = "";
	}
	print "Location: " . ForceUrl($url) . "\n\n";
	exit(0);
}

if ($Image =~ /^$/ && $Move =~ /^$/) {
	EditPage();
	exit(0);
}

# Ignore, if no image exists

# Edit image

if (defined($Edit) && $Edit !~ /^$/ && $Image > 0) {
	print "Location: edit.cgi?id=$Image\n\n";
	exit(0);
}

# Title picture

if (defined($TitlePic) && $TitlePic !~ /^$/) {
	if (AlbumImageIn($Album, $TitlePic)) {
		AlbumTitlePic($Album, $TitlePic);
	}
	print "Location: $Referer\n\n";
	exit(0);
}

# Move an image/album

if (defined($Move) && $Move !~ /^$/) {
	if ($Move eq "down") {
		$dir = 0;
	} elsif ($Move eq "up") {
		$dir = 1;
	}
	if ($Image < 1) {
		AlbumMove($Album, $dir);
	} else {
		AlbumMovePic($Album, $Image, $dir);
	}
	$tm = time;
	print "Location: " . ForceUrl("$Referer") . "\n\n";
	exit(0);
}
# delete one
if (defined($Delete) && $Delete !~ /^$/) {
my %db;
	AlbumDelPix($Album, $Image);
	($name) = AlbumIdName($Album);
	$tm = time;
	print "Location: " . ForceUrl("$Referer") . "\n\n";
	exit(0);
}

sub EditPage {

($alb,undef) = AlbumIdName($Album);
$descr = AlbumDescr($Album);
$keyw = AlbumKeywords($Album);

if (AlbumPublic($Album)) {
	$pubchecked = "checked";
	$privchecked = "";
} else {
	$pubchecked = "";
	$privchecked = "checked";
}


PrintHeader($User, "Edit Album", "", "Edit Album properties");

$parid = AlbumParent($Album, -1);
$title_id = AlbumTitlePic($Album);
if ($title_id > 0) {
	my($dir);
	($w,$h,$dir) = db_get_image_geom($title_id, 0);
	$w /= 3/2;
	$h /= 3/2;
	$titimg = $Repos_Url . $dir;
	$titlepic = "<img border=0 src=$titimg width=$w height=$h>";
} else {
	$titlepic = "&nbsp;";
}

if ($Referer =~ /albumshow/) {
	$where = "albumshow";
} elsif ($Referer =~ /albumlist/) {
	$where = "albumlist";
} else {
	$where = "";
}

print <<EOF;
<form method=post>
<input type=hidden name=action value=edit>
<input type=hidden name=album value=$Album>
<input type=hidden name=where value=$where>
<center>
<table border=0 width=300  cellspacing=1  bgcolor=$TableHighBG>
<tr bgcolor=$TableLowBG>
	<th colspan=2>
		<font color=$TextLoTable>Edit Album Properties
	</th>
</tr>
<tr>
	<td>
		<font color=$TextTable>
		<b>Album Name:</b><br>
	<input type=text name=albumname value="$alb">
	</td>
	<td align=center>
		$titlepic
	</td>
</tr>
<tr>
	<td colspan=2>
		<font color=$TextTable>
	<b>Album Description:</b><br>
	<input type=text name=albumdescr size=40 value="$descr">
	</td>
</tr>
<tr>
	<td colspan=2>
		<font color=$TextTable>
		<b>Keywords:</b><br>
	<input type=text name=albumkeywords size=40 value="$keyw">
	</td>
</tr>
<tr>
	<td>
		<font color=$TextTable>
		<b>Album is public?</b><br>
		<input type=radio name=public $pubchecked value=1> Public |
		<input type=radio name=public $privchecked value=0> Private
	</td>
	<td>
		<font color=$TextTable>
		<b>Parent album:</b><br>
		<select name=newparent>
EOF
@albs = AlbumList($User, 1);

foreach $alb (@albs) {
	($own,$name,$id,$prev,$next,$type) = split(/:/, $alb);
	$sel = ($id == $parid) ? "selected" : "";
	print "<option value=$id $sel>$name\n";
}

print <<EOF;
</select>

</tr>
<tr>
	<td  colspan=2 align=center>
		To update the title image, go to the actual album, click the 
		image you want to use, then click 'Set Title'.
	</td>
</tr>
<tr>
	<td align=center>
		<input type=submit name=update value=Update>
		<input type=submit name=cancel value=Cancel OnClick="javascript:history.go(-1)">
	</td>
	<td align=right>
		<input type=submit name=delete value=Delete OnClick="return confirm('Confirm album deletion!')">
	</td>
</tr>
</table></center>
<br>
EOF
PrintFooter();

}

